﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.Windows.Controls.GanttView;

namespace GanttMilitaryDates
{
    public class CustomGanttTask : GanttTask
    {
        private DateTime dDate;

        public CustomGanttTask(int dEndDeviation, int dStartDeviation, string title)
            : base()
        {
            this.dEndDeviation = dEndDeviation;
            this.dStartDeviation = dStartDeviation;
            this.Title = title;

            this.Duration = new TimeSpan(this.dEndDeviation - this.dStartDeviation, 0, 0, 0);
        }

        private int dStartDeviation;
        public int DStartDeviation
        {
            get
            {
                return this.dStartDeviation;
            }
            set
            {
                if (this.dStartDeviation != value)
                {
                    this.dStartDeviation = value;
                    this.OnPropertyChanged(() => this.DStartDeviation);
                    this.OnPropertyChanged(() => this.DSStartDeviation);
                    this.SetStartEndByDDate(this.dDate);
                }
            }
        }

        private int dEndDeviation;
        public int DEndDeviation
        {
            get
            {
                return this.dEndDeviation;
            }
            set
            {
                if (this.dEndDeviation != value)
                {
                    this.dEndDeviation = value;
                    this.OnPropertyChanged(() => this.DEndDeviation);
                    this.SetStartEndByDDate(this.dDate);
                }
            }
        }

        public string DSStartDeviation
        {
            get
            {
                if (dStartDeviation == 0)
                    return string.Empty;
                else if (dStartDeviation > 0)
                {

                    string s = "+" + dStartDeviation.ToString();
                    return s;
                }
                return dStartDeviation.ToString();
            }
        }

        public void SetStartEndByDDate(DateTime dDate = new DateTime())
        {
            this.dDate = dDate;
            if (this.dDate != default(DateTime))
            {
                this.Start = dDate.AddDays(this.DStartDeviation);
                this.End = dDate.AddDays(this.DEndDeviation);
            }
        }
    }
}
